//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers  1
#property indicator_color1   PaleVioletRed

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    ExtDepth     = 12;
extern int    ExtDeviation = 5;
extern int    ExtBackstep  = 3;

double zigzag[];
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,zigzag); SetIndexStyle(0,DRAW_SECTION); SetIndexEmptyValue(0,0.0);
      timeFrame = stringToTimeFrame(TimeFrame);
   return(0);
}

//
//
//
//
//

int start()
{
   int count,countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);
         for (count=0;limit<(Bars-1) && count<3; limit++)  if (zigzag[limit]!=0) count++;
   
   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+1]);
         if (x!=y)
               zigzag[i] = iCustom(NULL,timeFrame,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,y);
         else  zigzag[i] = 0;
   }         
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}